<?

include("../.global.php");

$sql="SELECT count(message) FROM logs";
$result=dbquery($sql);
$rs=dbnext($result);
$total=$rs[0];

$sql="SELECT count(id) from handles";
$result=dbquery($sql);
$rs=dbnext($result);
$loginsCnt=$rs[0];
$total=$total+$rs[0];

$sql="SELECT count(id) from buddies";
$result=dbquery($sql);
$rs=dbnext($result);
$buddyCnt=$rs[0];
$total=$total+$rs[0];



$sql="SELECT count(message) FROM logs WHERE message like 'File%'";
$result=dbquery($sql);
if(dbnumrows($result)){
  $rs=dbnext($result);
  $fileCnt=$rs[0];
}else{
  $fileCnt=0;
}

$sql="SELECT count(message) FROM logs WHERE message like '***CHAT%'";
$result=dbquery($sql);
if(dbnumrows($result)){
  $rs=dbnext($result);
  $chatCnt=$rs[0];
}else{
  $chatCnt=0;
}

$sql="SELECT count(message) FROM logs WHERE (message NOT LIKE 'File%' AND message NOT LIKE '***CHAT%')";
$result=dbquery($sql);
if(dbnumrows($result)){
  $rs=dbnext($result);
  $msgCnt=$rs[0];
}else{
  $msgCnt=0;
}


/* chart.php */  
$data = array(  
	      "Logins($loginsCnt)"=>(($loginsCnt/$total)*100),
	      "Buddy Lists($buddyCnt)"=>(($buddyCnt/$total)*100),
	      "File Xfers($fileCnt)"=>(($fileCnt/$total)*100),
	      "Chats($chatCnt)"=>(($chatCnt/$total)*100),
	      "Messages($msgCnt)"=>(($msgCnt/$total)*100)
);  

// create image 
$width = 480;  
$height = 250;  
$image = imagecreate($width, $height);  

// colors 
$white = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);  
$navy = imagecolorallocate($image, 0x00, 0x00, 0x80);  
$black = imagecolorallocate($image, 0x00, 0x00, 0x00);  
$gray = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);  
$red=imagecolorallocate($image,0xFF,0x00,0x00);

// layout 
$maxval = max($data);  
$nval = sizeof($data);  

$vmargin = 20; // top (bottom) vertical margin for title (x-labels) 
$hmargin = 38; // left horizontal margin for y-labels 

$base = floor(($width - $hmargin) / $nval); // distance between columns 

$ysize = $height - 2 * $vmargin; // y-size of plot 
$xsize = $nval * $base; // x-size of plot 

// title 
$titlefont = 3;  
$title = "IM Uses %";  

$txtsz = imagefontwidth($titlefont) * strlen($title); // pixel-width of title 

$xpos = (int)($hmargin + ($xsize - $txtsz)/2); // center the title 
$xpos = max(1, $xpos); // force positive coordinates 
$ypos = 3; // distance from top 

imagestring($image, $titlefont, $xpos, $ypos, $title , $black);  

// y labels and grid lines 
$labelfont = 2;  
$ngrid =9;//4; // number of grid lines 

$dydat = 10;//$maxval / $ngrid; // data units between grid lines 
$dypix = $ysize / ($ngrid + 1); // pixels between grid lines 

for ($i = 0; $i <= ($ngrid + 1); $i++) {  
    // iterate over y ticks 

    // height of grid line in units of data 
    $ydat = (int)($i * $dydat);  

    // height of grid line in pixels 
    $ypos = $vmargin + $ysize - (int)($i*$dypix);  

    $txtsz = imagefontwidth($labelfont) * strlen($ydat); // pixel-width of label 
    $txtht = imagefontheight($labelfont); // pixel-height of label 

    $xpos = (int)(($hmargin - $txtsz) / 2);  
    $xpos = max(1, $xpos);  

    imagestring($image, $labelfont, $xpos,  
        $ypos - (int)($txtht/2), $ydat, $black);  

    if (!($i == 0) && !($i > $ngrid)) { 
        imageline($image, $hmargin - 3,  
            $ypos, $hmargin + $xsize, $ypos, $gray);  
        // don't draw at Y=0 and top 
    } 
}  

// columns and x labels 
$padding = 3; // half of spacing between columns 
$yscale = $ysize / (($ngrid+1) * $dydat); // pixels per data unit 

for ($i = 0; list($xval, $yval) = each($data); $i++) {  

    // vertical columns 
    $ymax = $vmargin + $ysize;  
    $ymin = $ymax - (int)($yval*$yscale);  
    $xmax = $hmargin + ($i+1)*$base - $padding;  
    $xmin = $hmargin + $i*$base + $padding;  

    imagefilledrectangle($image, $xmin, $ymin, $xmax, $ymax, $red);  

    // x labels 
    $txtsz = imagefontwidth($labelfont) * strlen($xval);  

    $xpos = $xmin + (int)(($base - $txtsz) / 2);  
    $xpos = max($xmin, $xpos);  
    $ypos = $ymax + 3; // distance from x axis 

    imagestring($image, $labelfont, $xpos, $ypos, $xval, $black);  
}  

// plot frame 
imagerectangle($image, $hmargin, $vmargin,  
    $hmargin + $xsize, $vmargin + $ysize, $black);  

//$srcImage=imageCreateFrompng("./images/logo.png");
//$srcWidth=imageSX(//$srcImage);
//$srcHeight=imageSY(//$srcImage);
//imagecopymerge($image,//$srcImage,$hmargin,$vmargin,0,0,//$srcWidth,//$srcHeight,"50");

// flush image 
header("Content-type: image/png"); // or "Content-type: image/png" 
imagepng($image); // or imagepng($image) 
imagedestroy($image);

?>

