<?

include("../.global.php");

$title = "Messages Per Day Of Week";  

$sql2="SELECT DATE_FORMAT(ts,\"%a\") as dayoW, count(message) as msgCnt FROM logs WHERE direction='00040007' GROUP BY dayoW ORDER BY DATE_FORMAT(ts,\"%w\") ASC";
$result=dbquery($sql2);
$incomingData=array();
while($rs=dbnext($result)){
  //  echo "$rs[0]=$rs[1]<BR>";
  $incomingData[$rs[0]]=$rs[1];
}
//echo "INCOMING DATA: ".$incomingData["Sat"]."<BR>";
$sql="SELECT DATE_FORMAT(ts,\"%a\") as dayoW, count(message) as msgCnt FROM logs WHERE direction='00040006' GROUP BY dayoW ORDER BY DATE_FORMAT(ts,\"%w\") ASC";
$result=dbquery($sql);
$data=array();
while($rs=dbnext($result)){
  $temp1=array($rs[0]."(Out: $rs[1] In: $rs[0])",$rs[1],$incomingData[$rs[0]]);
  $data["$rs[0]"]=array($rs[1],$incomingData[$rs[0]]);
  //  echo "$rs[0]=$rs[1] , ".$incomingData[$rs[0]]."<BR>";
  //  echo $data."<BR>";
  //  $temp=$data[$rs[0]];
  //  echo $data[$rs[0]]."<BR>".$temp[0]."<BR><HR>";
}


// create image 
$width = 900;  
$height = 200;  
$image = imagecreate($width, $height);  

// colors 
$white = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);  
$navy = imagecolorallocate($image, 0x00, 0x00, 0x80);  
$black = imagecolorallocate($image, 0x00, 0x00, 0x00);  
$gray = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);  
$red=imagecolorallocate($image,0xFF,0x00,0x00);

// layout 
foreach($data as $value){
  if(max($value[1],$value[2])>$maxval){
    //    echo "$value[1] or $value[2]<BR>";
    $maxval=max($value);
  }
}
  
//echo "MAX: $maxval<BR>";
$nval = (sizeof($data)*2);  
//echo "NVAL: $nval<BR>";

$vmargin = 30; // top (bottom) vertical margin for title (x-labels) 
$hmargin = 38; // left horizontal margin for y-labels 

$base = floor(($width - $hmargin) / $nval); // distance between columns 

$ysize = $height - 2 * $vmargin; // y-size of plot 
$xsize = $nval * $base; // x-size of plot 

// title 
$titlefont = 3;  


$txtsz = imagefontwidth($titlefont) * strlen($title); // pixel-width of title 

$xpos = (int)($hmargin + ($xsize - $txtsz)/2); // center the title 
$xpos = max(1, $xpos); // force positive coordinates 
$ypos = 3; // distance from top 

imagestring($image, $titlefont, $xpos, $ypos, $title , $black);  

// y labels and grid lines 
$labelfont = 2;  
$ngrid =4; // number of grid lines 

$dydat = $maxval / $ngrid; // data units between grid lines 
//echo "DYDAT: $maxval/$ngrid $dydat<BR>";
$dypix = $ysize / ($ngrid + 1); // pixels between grid lines 

for ($i = 0; $i <= ($ngrid + 1); $i++) {  
    // iterate over y ticks 

    // height of grid line in units of data 
    $ydat = (int)($i * $dydat);  

    // height of grid line in pixels 
    $ypos = $vmargin + $ysize - (int)($i*$dypix);  

    $txtsz = imagefontwidth($labelfont) * strlen($ydat); // pixel-width of label 
    $txtht = imagefontheight($labelfont); // pixel-height of label 

    $xpos = (int)(($hmargin - $txtsz) / 2);  
    $xpos = max(1, $xpos);  

    imagestring($image, $labelfont, $xpos,  
        $ypos - (int)($txtht/2), $ydat, $black);  

    if (!($i == 0) && !($i > $ngrid)) { 
        imageline($image, $hmargin - 3,  
            $ypos, $hmargin + $xsize, $ypos, $gray);  
        // don't draw at Y=0 and top 
    } 
}  

// columns and x labels 
$padding = 3; // half of spacing between columns 
$yscale = $ysize / (($ngrid+1) * $dydat); // pixels per data unit 

reset($data);
for ($i = 0; $values = each($data); $i++) {  
  $xval=$values[0]; $yvalary=$values[1];
  //  echo "XVAL: $xval YVAL: $yval<BR>";
  $yval=$yvalary[0];
  $yval2=$yvalary[1];
  //echo "Xmin: $xmin  Xmax: $xmax Xsize: $xsizeseg<BR>";
    // vertical columns 
  $ymax = $vmargin + $ysize;  
  $ymin = $ymax - (int)($yval*$yscale);  
  if($xmin){
    $xmin=$xmax-+$padding+($base/4);
  }else{
    $xmin = $hmargin + ($i)*$base + $padding;  
  }
  if($xmax){
    $xmax=$xmin + $xsizeseg;// - $padding;
  }else{
    $xmax = $hmargin + ($i+1)*$base-$padding;  
  }
  if(!$xsizeseg){
    $xsizeseg=$xmax-$xmin;
  }
  if($xmin>$xmax){
    $temp=$xmax;
    $xmax=$xmin+$xsizeseg;
    $xmin=$temp;
  }
  //  echo "DIFF: $xsizeseg<BR>";
  imagefilledrectangle($image, $xmin, $ymin, $xmax, $ymax, $red);  
  imagestring($image, $labelfont, ($xmin), $ymax+3, "Out: $yval", $red); 

  //   echo "Out: Xmin: $xmin  Ymin: $ymin  Xmax: $xmax  Ymax: $ymax<BR>";

  $ymin2=$ymax-(int)($yval2*$yscale);
  $xmin=$xmax;
  $xmax=$xmax + $xsizeseg-$padding;
  imagefilledrectangle($image, $xmin, $ymin2, $xmax-$padding, $ymax, $navy);
  imagestring($image, $labelfont, ($xmin), $ymax+13, "In: $yval2", $navy);
  //  echo "Inc: Xmin: $xmin  Ymin: $ymin  Xmax: $xmax  Ymax: $ymax<BR><HR>";
  
  
  
  // x labels 
  $txtsz = imagefontwidth($labelfont) * strlen($xval);  
  
  $xpos = ($xmin-$xsizeseg) + (int)(($base - $txtsz) / 2);  
  $xpos = max(($xmin-$xsizeseg), $xpos);  
  $ypos = $ymax + 15; // distance from x axis 
  //$xpos=$xmax-($xsizeseg);
  
  imagestring($image, $labelfont+4, $xpos, $ypos, $xval, $black);  
}  

// plot frame 
imagerectangle($image, $hmargin, $vmargin,  
    $hmargin + $xsize, $vmargin + $ysize, $black);  

//$srcImage=imageCreateFrompng("./images/logo.png");
//$srcWidth=imageSX(//$srcImage);
//$srcHeight=imageSY(//$srcImage);
//imagecopymerge($image,//$srcImage,$hmargin,$vmargin,0,0,//$srcWidth,//$srcHeight,"50");

// flush image 
header("Content-type: image/png"); // or "Content-type: image/png" 
imagepng($image); // or imagepng($image) 
imagedestroy($image);

?>

