<?

include("../.global.php");

$title = "Outgoing Messages Per Day Of Week";  

$sql="SELECT DATE_FORMAT(ts,\"%a\") as dayoW, count(message) as msgCnt FROM logs WHERE direction='00040006' GROUP BY dayoW ORDER BY DATE_FORMAT(ts,\"%w\") DESC";
$result=dbquery($sql);
$data=array();
while($rs=dbnext($result)){
  $temp=array("$rs[0]($rs[1])"=>$rs[1]);
  $temp2=$data;
  $data=array_merge($temp,$temp2);
}



// create image 
$width = 900;  
$height = 200;  
$image = imagecreate($width, $height);  

// colors 
$white = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);  
$navy = imagecolorallocate($image, 0x00, 0x00, 0x80);  
$black = imagecolorallocate($image, 0x00, 0x00, 0x00);  
$gray = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);  
$red=imagecolorallocate($image,0xFF,0x00,0x00);

// layout 
$maxval = max($data);  
//echo "MAX: $maxval<BR>";
$nval = sizeof($data);  
//echo "NVAL: $nval<BR>";

$vmargin = 20; // top (bottom) vertical margin for title (x-labels) 
$hmargin = 38; // left horizontal margin for y-labels 

$base = floor(($width - $hmargin) / $nval); // distance between columns 

$ysize = $height - 2 * $vmargin; // y-size of plot 
$xsize = $nval * $base; // x-size of plot 

// title 
$titlefont = 3;  


$txtsz = imagefontwidth($titlefont) * strlen($title); // pixel-width of title 

$xpos = (int)($hmargin + ($xsize - $txtsz)/2); // center the title 
$xpos = max(1, $xpos); // force positive coordinates 
$ypos = 3; // distance from top 

imagestring($image, $titlefont, $xpos, $ypos, $title , $black);  

// y labels and grid lines 
$labelfont = 2;  
$ngrid =4; // number of grid lines 

$dydat = $maxval / $ngrid; // data units between grid lines 
//echo "DYDAT: $maxval/$ngrid $dydat<BR>";
$dypix = $ysize / ($ngrid + 1); // pixels between grid lines 

for ($i = 0; $i <= ($ngrid + 1); $i++) {  
    // iterate over y ticks 

    // height of grid line in units of data 
    $ydat = (int)($i * $dydat);  

    // height of grid line in pixels 
    $ypos = $vmargin + $ysize - (int)($i*$dypix);  

    $txtsz = imagefontwidth($labelfont) * strlen($ydat); // pixel-width of label 
    $txtht = imagefontheight($labelfont); // pixel-height of label 

    $xpos = (int)(($hmargin - $txtsz) / 2);  
    $xpos = max(1, $xpos);  

    imagestring($image, $labelfont, $xpos,  
        $ypos - (int)($txtht/2), $ydat, $black);  

    if (!($i == 0) && !($i > $ngrid)) { 
        imageline($image, $hmargin - 3,  
            $ypos, $hmargin + $xsize, $ypos, $gray);  
        // don't draw at Y=0 and top 
    } 
}  

// columns and x labels 
$padding = 3; // half of spacing between columns 
$yscale = $ysize / (($ngrid+1) * $dydat); // pixels per data unit 

for ($i = 0; list($xval, $yval) = each($data); $i++) {  
  //   echo "XVAL: $xval YVAL: $yval<BR>";
    // vertical columns 
    $ymax = $vmargin + $ysize;  
  // echo "$ymax - (int)($yval*$yscale)<BR>";
    $ymin = $ymax - (int)($yval*$yscale);  
    $xmax = $hmargin + ($i+1)*$base - $padding;  
    $xmin = $hmargin + $i*$base + $padding;  

    imagefilledrectangle($image, $xmin, $ymin, $xmax, $ymax, $red);  

    // x labels 
    $txtsz = imagefontwidth($labelfont) * strlen($xval);  

    $xpos = $xmin + (int)(($base - $txtsz) / 2);  
    $xpos = max($xmin, $xpos);  
    $ypos = $ymax + 3; // distance from x axis 

    imagestring($image, $labelfont, $xpos, $ypos, $xval, $black);  
}  

// plot frame 
imagerectangle($image, $hmargin, $vmargin,  
    $hmargin + $xsize, $vmargin + $ysize, $black);  

//$srcImage=imageCreateFrompng("./images/logo.png");
//$srcWidth=imageSX(//$srcImage);
//$srcHeight=imageSY(//$srcImage);
//imagecopymerge($image,//$srcImage,$hmargin,$vmargin,0,0,//$srcWidth,//$srcHeight,"50");

// flush image 
header("Content-type: image/png"); // or "Content-type: image/png" 
imagepng($image); // or imagepng($image) 
imagedestroy($image);

?>

